/*
 * Hexecute 3.0
 * CalcPosition.cpp
 * copyright 2000 Mike Walston
 *
 * This code is what is used to determine where the cursor should
 * go when doing key navigation on table based text, its 0wnz0ry
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

int CalcPosition(int* Positions, int yPos)
{
	int a;
	if(CurrentTable == -1 )
	{
		Positions[16] = 50; 
		Positions[17] = 51;
		Positions[18] = 52;
		Positions[19] = 53;
		Positions[20] = 54;
		Positions[21] = 55;
		Positions[22] = 56;
		Positions[23] = 57;
		Positions[24] = 58; 
		Positions[25] = 59;
		Positions[26] = 60;
		Positions[27] = 61;
		Positions[28] = 62;
		Positions[29] = 63;
		Positions[30] = 64;
		Positions[31] = 65;
	}
	else
	{
		Positions[16] = 50; // this is the starting point and always the same
							// we calculate our positions based on this
		// we're going to integrate the painting routine and this so I can tell
		// if there are hex values on a row that are already represented in the 
		// above row where the caret isn't
		for(a = 0; a < LeftOverChars[yPos]; a++)
		{
			Positions[17 + a] = 50;
		}

	}
	return 0;
}

int ResetPosition(int* Positions)
{
	return 0;
}