/*
 * Hexecute 3.0
 * CloseFiles.cpp
 * copyright 2000 Mike Walston
 *
 * This code is what is called when New File and Open File
 * are used while a file is already opened
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

int CloseFiles(HWND hWnd)
{
	char Caption[_MAX_PATH];
	
	wsprintf(Caption, "%s %d.%d.%d", PROGRAM_NAME, PROGRAM_MAJOR, PROGRAM_MINOR, PROGRAM_BUILD);
	SetWindowText(hWnd, Caption);
	FileOpen = 0;
	GlobalFree(File);
	TotalTables = 0;
	CurrentTable = -1;
	DefaultMenu();
	return 0;
}