/*
 * Hexecute 3.0
 * Initialize.cpp
 * copyright 2000 Mike Walston
 * 
 * This contains the class/other initialization functions
 */

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

void InitializeWndClassMain(WNDCLASS *wndclass, HINSTANCE hInstance)
{
	wndclass->style = CS_HREDRAW | CS_VREDRAW;
	wndclass->lpfnWndProc = WinProc;
	wndclass->cbClsExtra = 0;
	wndclass->cbWndExtra = 0;
	wndclass->hInstance = hInstance;
	wndclass->hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
	wndclass->hCursor = LoadCursor(NULL, IDC_ARROW);
	wndclass->hbrBackground = (HBRUSH)(COLOR_APPWORKSPACE);
	wndclass->lpszMenuName = TEXT("HexecuteMenu");
	wndclass->lpszClassName = MainClass;
}

void InitializeWndClassData(WNDCLASS *wndclass, HINSTANCE hInstance)
{
	wndclass->style = CS_HREDRAW | CS_VREDRAW;
	wndclass->lpfnWndProc = DataWinProc;
	wndclass->cbClsExtra = 0;
	wndclass->cbWndExtra = 0;
	wndclass->hInstance = hInstance;
	wndclass->hIcon = NULL/*LoadIcon(NULL, IDI_APPLICATION)*/;
	wndclass->hCursor = LoadCursor(NULL, IDC_ARROW);
	wndclass->hbrBackground = GetStockBrush(WHITE_BRUSH);;
	wndclass->lpszMenuName = NULL;
	wndclass->lpszClassName = DataClass;
}
