/*
 * Hexecute 3.0
 * Searches.cpp
 * copyright 2000 Mike Walston
 *
 * This code is what is used to determine where the cursor should
 * go when doing key navigation on table based text, its 0wnz0ry
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

search_struct SearchData;

int RelativeSearch(char* SearchString, int Length, int StartAddress)
{
	int b, counter = 0;
	for(int a = StartAddress + 1; a < MaxAddress; a += b + 1)
	//for(int a = StartAddress + 1; a < MaxAddress; a++)
	{
		for(b = 0; b < Length - 1; b++)
		{
			// if it isn't an asterisk and therefore NEVER a wild card
			if( SearchString[b] != '*' )
			{
				if( ( GetFileByte(a + b) - GetFileByte(a + b + 1) ) != 
					( SearchString[b] - SearchString[b + 1] ) )
					break;
			}
			// if it's an asterisk that isn't a wild card
			else if ( isValue[counter] == true )
			{
				counter++;
				if( ( GetFileByte(a + b) - GetFileByte(a + b + 1) ) != 
					( SearchString[b] - SearchString[b + 1] ) )
					break;

			}
			// it's a wild card
			else 
			{
				counter++;
			}
		}
		if (b == Length - 1)
		{
			HighlightOn = YES;
			startHighlight = a;
			endHighlight = a + Length;
			return a;
		}
	}
	return 0;
}

int ValueSearch(char* SearchString, int Length, int StartAddress)
{
	int b, counter = 0;
	for(int a = StartAddress + 1; a < MaxAddress; a += ( b + 1 ) )
	{
		for(b = 0; b < Length; b++)
		{
			// a nonasterisk
			if( SearchString[b] != '*' )
			{
				if( ( GetFileByte(a + b) != SearchString[b] ) ) 
					break;
			}
			// if it's an asterisk that isn't a wild card
			else if ( isValue[counter] == true )
			{
				counter++;
				if( ( GetFileByte(a + b) != SearchString[b] ) ) 
					break;
			}
			// it's a wild card
			else
			{
				counter++;
			}
		}
		if (b == Length)
		{
			HighlightOn = YES;
			startHighlight = a;
			endHighlight = a + Length;
			return a;
		}
	}
	return 0;
}
