/*
 * Hexecute 3.0
 * TableEditor.cpp
 * copyright 2000 Mike Walston
 *
 * The table file editor
 */

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <process.h>
#include <tchar.h>
#include <richedit.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

POINT TopLeft, BottomRight, IsClicked, OldIsClicked;
int  SubStringDisplayed, ScrollPosition, NumDisplayed,codepage;

BOOL CALLBACK TableFileEditorEditWindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
//	HDC hdcEdit;
	POINT blah;
	HWND F003y;
//	RECT bleh, *f00;
	int /* l, b, q, c, o, i, */r = 0/*, romh*/;
//	tableEntry* yeehaw;
	int MASK[4] = { 0xFF, 0xFF00, 0xFF0000, 0xFF000000 };
	unsigned int poop;
	char temp2[500]/*, whatever[4]*/;
	char script[65356];

		switch(message){

			case WM_INITDIALOG:
				if(IsClicked.x)
					SendDlgItemMessage(hWnd, IDC_EDIT1, EM_SETLIMITTEXT , 32, 0);
				else
					SendDlgItemMessage(hWnd, IDC_EDIT1, EM_SETLIMITTEXT , 8, 0);
				F003y = GetDlgItem(GetParent(hWnd), IDC_BIGBUTTON);
				blah.x = TopLeft.x;
				blah.y = TopLeft.y;
				ClientToScreen(F003y, &blah);
				MoveWindow(hWnd, blah.x + 1, blah.y + 1, BottomRight.x , BottomRight.y - 2,TRUE);
				if(IsClicked.x)
				{
					// this is a new value that we have
					if(IsClicked.y == Table[CurrentTable]->Entries[SubStringDisplayed])
						SetDlgItemText(hWnd, IDC_EDIT1, "");
					else
						SetDlgItemText(hWnd, IDC_EDIT1, Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].string);
				}
				else
				{
					if(IsClicked.y == Table[CurrentTable]->Entries[SubStringDisplayed])
						SetDlgItemText(hWnd, IDC_EDIT1, "");
					else
					{
						if(Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].value > 0xFFFFFF)
							wsprintf(temp2, "%08X", Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].value);
						else if (Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].value > 0xFFFF)
							wsprintf(temp2, "%06X", Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].value);
						else if (Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].value > 0xFF)
							wsprintf(temp2, "%04X", Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].value);
						else 
							wsprintf(temp2, "%02X", Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].value);
						SetDlgItemText(hWnd, IDC_EDIT1, temp2);
					}
				}
				return (TRUE);

			case WM_COMMAND:
				switch(HIWORD(wParam)) {
					case EN_KILLFOCUS:
						EndDialog(hWnd, 0);
						return (TRUE);
	
					case EN_UPDATE:
						GetDlgItemText(hWnd, IDC_EDIT1, script, 65355);
						
						if(script[strlen(script) - 1 ] == '\n')
						{
							// if this isn't a new value then we do our thing
							if(IsClicked.y != Table[CurrentTable]->Entries[SubStringDisplayed])
							{
								if(IsClicked.x)
								{
									// here we copy the string into the new value
									ZeroMemory(temp2, 500);
									GetDlgItemText(hWnd, IDC_EDIT1, temp2, 500);
									for(poop = 0; poop < 500; poop++)
									{
										if(temp2[poop] == 0x0d){
											temp2[poop] = 0x00;
											break;
										}
									}
									if(temp2[0] == 0x00)
									{
										EndDialog(hWnd, 0);
										return true;
									}
									if(strcmp(temp2, Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].string))
										Table[CurrentTable]->changed = true;
									Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].string = new char[strlen(temp2)];
									_tcscpy(Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].string, temp2);
									Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].string[strlen(temp2)] = 0x00;
								}
								else
								{
									// here we parse the string checking for valid hex chars only
									// here we copy the string into the new value
									ZeroMemory(temp2, 500);
									GetDlgItemText(hWnd, IDC_EDIT1, temp2, 500);
									for(poop = 0; poop < 500; poop++)
									{
										if(temp2[poop] == 0x0d){
											temp2[poop] = 0x00;
											break;
										}
									}
									if(temp2[0] == 0x00)
									{
										EndDialog(hWnd, 0);
										return true;
									}
									for(poop = 0; poop < strlen(temp2); poop++)
									{
										if(!isxdigit(temp2[poop]))
										{
											EndDialog(hWnd, 0);
											return true;
										}
									}
									Table[CurrentTable]->tableData[SubStringDisplayed][IsClicked.y].value = strtoul(temp2, NULL, 16);
								}
							}
							// this is if it's a new value, unfortunately due to how I constructed
							// the table file class, this isn't going to be easy, although I think what
							// I'm going to do is something like this table::Append(int, char*), or something
							// similar
							else
							{
								if(IsClicked.x)
								{
									// here we copy the string into the new value
									ZeroMemory(temp2, 500);
									GetDlgItemText(hWnd, IDC_EDIT1, temp2, 500);
									for(poop = 0; poop < 500; poop++)
									{
										if(temp2[poop] == 0x0d){
											temp2[poop] = 0x00;
											break;
										}
									}
									if(temp2[0] == 0x00)
									{
										EndDialog(hWnd, 0);
										return true;
									}
									Table[CurrentTable]->Append(00, temp2, SubStringDisplayed);
								}
								else
								{
									// here we parse the string checking for valid hex chars only
									// here we copy the string into the new value
									ZeroMemory(temp2, 500);
									GetDlgItemText(hWnd, IDC_EDIT1, temp2, 500);
									for(poop = 0; poop < 500; poop++)
									{
										if(temp2[poop] == 0x0d){
											temp2[poop] = 0x00;
											break;
										}
									}
									if(temp2[0] == 0x00)
									{
										EndDialog(hWnd, 0);
										return true;
									}
									for(poop = 0; poop < strlen(temp2); poop++)
									{
										if(!isxdigit(temp2[poop]))
										{
											EndDialog(hWnd, 0);
											return true;
										}
									}
									Table[CurrentTable]->Append(strtoul(temp2, NULL, 16), "", SubStringDisplayed);
								}
							}
						EndDialog(hWnd, 1);
						}
						return (TRUE);
	
					default:
						return (FALSE);
				}
				return (TRUE);
			default:
				return (FALSE);
		}
}

BOOL CALLBACK TableEditorProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	RECT rect;
	HBITMAP hbmMem, hbmOld;
	HBRUSH hbrBkGnd;
	HDC hMemDC;
	SIZE Size;
	LPDRAWITEMSTRUCT pdis;
	SCROLLINFO si;
	HDC tempDC;
	POINT CursorPosition;
	LOGFONT Fonty;
	TEXTMETRIC tm;
	bool IsThisRow = false;
	int cy1, cy2, blah, a, CPCounter;
	static int RowHeight, MaxHexDataWidth, ScrollWidth;
	static HWND hCustomWindow, hWndVScrollBar;
	static HFONT hFontCodePage, hFontData;
	char temp[100];
	
	switch(message) {

		case WM_INITDIALOG:

			// we get the system width of vertical scrollbars
			//ScrollWidth = GetSystemMetrics(SM_CXVSCROLL);

			SubStringDisplayed = 0;
			IsClicked.x = 0;
			IsClicked.y = 0;
			OldIsClicked.x = 1;
			OldIsClicked.y = 1;

			SetDlgItemText(hWnd, IDC_SUBSTRING_COMBO, "Main");
			SendMessage(GetDlgItem(hWnd, IDC_SUBSTRING_COMBO), CB_ADDSTRING, NULL, (LPARAM)TEXT("Main"));
			for (CPCounter = 1; CPCounter <= Table[CurrentTable]->SubTables; CPCounter++ )
			{
				wsprintf(temp, "%02X", Table[CurrentTable]->SubTableKeys[CPCounter]);
				SendMessage(GetDlgItem(hWnd, IDC_SUBSTRING_COMBO), CB_ADDSTRING, NULL, (LPARAM)temp);
			}

			wsprintf(temp, "%d", Table[CurrentTable]->getCodepage());
			SetDlgItemText(hWnd, IDC_COMBO_CODEPAGES, temp);
			SendMessage(GetDlgItem(hWnd, IDC_COMBO_CODEPAGES), CB_ADDSTRING, NULL, (LPARAM)temp);
			for (CPCounter = 0; CPCounter < InstalledPage; CPCounter++ )
			{
				wsprintf(temp, "%d", CPages[CPCounter].CodePageNum);
				SendMessage(GetDlgItem(hWnd, IDC_COMBO_CODEPAGES), CB_ADDSTRING, NULL, (LPARAM)temp);
			}

			// here we're going to go through the table 
			// and fill out box with entries, we're also
			hCustomWindow = GetDlgItem(hWnd, IDC_BIGBUTTON);

			tempDC = GetDC(hCustomWindow);

			GetClientRect(hCustomWindow, &rect);

			codepage = Table[CurrentTable]->getCodepage();

			switch(codepage) {
				case 874:
					Fonty = CPages[GetCPIndex(874)].logFont;
					Fonty.lfHeight = 16;
					break;
				case 932:
					Fonty = CPages[GetCPIndex(932)].logFont;
					Fonty.lfHeight = 16;
					break;
				case 936:
					Fonty = CPages[GetCPIndex(936)].logFont;
					Fonty.lfHeight = 16;
					break;
				case 949:
					Fonty = CPages[GetCPIndex(949)].logFont;
					Fonty.lfHeight = 16;
					break;
				case 950:
					Fonty = CPages[GetCPIndex(950)].logFont;
					Fonty.lfHeight = 16;
					break;
				case 1252:
					Fonty = CPages[GetCPIndex(1252)].logFont;
					Fonty.lfHeight = 16;
					break;
			}
			hFontCodePage = CreateFontIndirect(&Fonty);

			// creating the font for the output of the data
			Fonty.lfQuality = DRAFT_QUALITY;
			Fonty.lfCharSet = DEFAULT_CHARSET;
			_tcscpy(Fonty.lfFaceName, HexFontName); // sets the font face to Courier
            Fonty.lfHeight = 16;		// the height of the desired font is 12
            Fonty.lfWidth = 0;                          // use the default width
            Fonty.lfWeight = FW_NORMAL;						 // use normal thickness
            Fonty.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;	// use a fixed pitch font
            hFontData = CreateFontIndirect(&Fonty);	// create the logical font
			
			SelectObject(tempDC, hFontData);
			GetTextMetrics(tempDC, &tm);
			cy1 = tm.tmHeight + tm.tmExternalLeading + 2;

			SelectObject(tempDC, hFontCodePage);
			GetTextMetrics(tempDC, &tm);
			cy2 = tm.tmHeight + tm.tmExternalLeading + 2;

			if(cy1 > cy2)
				RowHeight = cy1;
			else RowHeight = cy2;

			SelectObject(tempDC, hFontData);
			wsprintf(temp, " 00000000");
			GetTextExtentPoint32(tempDC, temp, strlen(temp), &Size);
			NumDisplayed = rect.bottom / RowHeight + 1;
			MaxHexDataWidth = Size.cx;
			ReleaseDC(hCustomWindow, tempDC);

			// here we intialize the combo box and the edit control
			_tcscpy(temp, Table[CurrentTable]->getName());
			// need to take out the (codepage) from the end of the table file name
			// because it's not needed in the editor
			for(a = strlen(temp) - 1; temp[a] != '('; a--)
				temp[a] = 0x00;
			temp[a] = 0x00;

			SetDlgItemText(hWnd, IDC_TABLE_NAME, temp);

			si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_ALL;
			si.nMin = 0;
			si.nPos = 0;
			si.nMax = Table[CurrentTable]->Entries[SubStringDisplayed] + 1;
			si.nPage =  NumDisplayed;
			SetScrollInfo(GetDlgItem(hWnd, IDC_VSCROLLBAR), SB_CTL, &si, TRUE);
			break;

	case WM_DRAWITEM:

		pdis = (LPDRAWITEMSTRUCT) lParam;

		switch(pdis->CtlID) {

		case IDC_BIGBUTTON:

			si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_ALL;
			GetScrollInfo(GetDlgItem(hWnd, IDC_VSCROLLBAR), SB_CTL, &si);
			ScrollPosition = si.nPos;

			hMemDC = CreateCompatibleDC(pdis->hDC);
			hbmMem = CreateCompatibleBitmap(pdis->hDC,
                                    pdis->rcItem.right-pdis->rcItem.left,
                                    pdis->rcItem.bottom-pdis->rcItem.top);
			hbmOld = (HBITMAP)SelectObject(hMemDC, hbmMem);

			hbrBkGnd = CreateSolidBrush(0x00FFFFFF);
			FillRect(hMemDC, &pdis->rcItem, hbrBkGnd);
			DeleteObject(hbrBkGnd);

			// here we draw the vertical line
			MoveToEx(hMemDC, MaxHexDataWidth, 0, NULL);
			LineTo (hMemDC, MaxHexDataWidth, pdis->rcItem.bottom);
		
			// now we draw the horizontal lines
			for(int a = 0; a <= NumDisplayed; a++)
			{
				MoveToEx(hMemDC, 0, RowHeight * a, NULL);
				LineTo(hMemDC, pdis->rcItem.right, RowHeight * a);
			}
			blah = 2;
			for(int c = ScrollPosition ; 
				( c <= NumDisplayed + ScrollPosition) && ( c <= Table[CurrentTable]->Entries[SubStringDisplayed] );
				c++)
			{
				if( c == IsClicked.y )
				{
					rect.bottom = RowHeight * ( ( c - ScrollPosition) + 1) ;
					rect.top = RowHeight * ( c - ScrollPosition ) ;
					if( c != Table[CurrentTable]->Entries[SubStringDisplayed])
					{
						if(IsClicked.x)
						{
							rect.right = MaxHexDataWidth;
							rect.left = pdis->rcItem.right;
							FillRect(hMemDC, &rect, CreateSolidBrush(0x00000000));

							SetBkColor(hMemDC, 0x00FFFFFF);
							SetTextColor(hMemDC, 0x00000000);

							SelectObject(hMemDC, hFontData);
							if(Table[CurrentTable]->tableData[SubStringDisplayed][c].value > 0xFFFFFF)
								wsprintf(temp, "%08X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							else if (Table[CurrentTable]->tableData[SubStringDisplayed][c].value > 0xFFFF)
								wsprintf(temp, "%06X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							else if (Table[CurrentTable]->tableData[SubStringDisplayed][c].value > 0xFF)
								wsprintf(temp, "%04X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							else 
								wsprintf(temp, "%02X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							TextOut(hMemDC, 2, blah, temp, strlen(temp));

							SetBkColor(hMemDC, 0x00000000);
							SetTextColor(hMemDC, 0x00FFFFFF);

							_tcscpy(temp, Table[CurrentTable]->tableData[SubStringDisplayed][c].string);
							SelectObject(hMemDC, hFontCodePage);
							TextOut(hMemDC, MaxHexDataWidth + 2, blah, temp, strlen(temp));
							blah += RowHeight;
						}
						else
						{
							rect.right = MaxHexDataWidth;
							rect.left = 0;						
							FillRect(hMemDC, &rect, CreateSolidBrush(0x00000000));

							SetBkColor(hMemDC, 0x00000000);
							SetTextColor(hMemDC, 0x00FFFFFF);

							SelectObject(hMemDC, hFontData);
							if(Table[CurrentTable]->tableData[SubStringDisplayed][c].value > 0xFFFFFF)
								wsprintf(temp, "%08X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							else if (Table[CurrentTable]->tableData[SubStringDisplayed][c].value > 0xFFFF)
								wsprintf(temp, "%06X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							else if (Table[CurrentTable]->tableData[SubStringDisplayed][c].value > 0xFF)
								wsprintf(temp, "%04X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							else 
								wsprintf(temp, "%02X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							TextOut(hMemDC, 2, blah, temp, strlen(temp));

							SetBkColor(hMemDC, 0x00FFFFFF);
							SetTextColor(hMemDC, 0x00000000);

							_tcscpy(temp, Table[CurrentTable]->tableData[SubStringDisplayed][c].string);
							SelectObject(hMemDC, hFontCodePage);
							TextOut(hMemDC, MaxHexDataWidth + 2, blah, temp, strlen(temp));
							blah += RowHeight;
						}
					}
					// this is so the last one is drawn completely on the screen
					// this would be nice
					else
					{
						if(IsClicked.x)
						{
							rect.right = pdis->rcItem.right;
							rect.left = MaxHexDataWidth;
							FillRect(hMemDC, &rect, CreateSolidBrush(0x00000000));
							SelectObject(hMemDC, CreatePen( PS_DOT, 1, 0x00FFFFFF));
							SelectObject(hMemDC, CreateSolidBrush(0x00000000));
							Rectangle(hMemDC, rect.left + 1, rect.top + 1, rect.right- 1 , rect.bottom);
							SetBkColor(hMemDC, 0x00FFFFFF);
							SetTextColor(hMemDC, 0x00000000);
							blah += RowHeight;
						}
						else
						{
							rect.right = MaxHexDataWidth;
							rect.left = 0;						
							FillRect(hMemDC, &rect, CreateSolidBrush(0x00000000));
							SelectObject(hMemDC, CreatePen( PS_DOT, 1, 0x00FFFFFF));
							SelectObject(hMemDC, CreateSolidBrush(0x00000000));
							Rectangle(hMemDC, rect.left + 1, rect.top + 1, rect.right, rect.bottom);
							SetBkColor(hMemDC, 0x00000000);
							SetTextColor(hMemDC, 0x00FFFFFF);
							blah += RowHeight;
						}
					}
				}
				else
				{
					if( c != Table[CurrentTable]->Entries[SubStringDisplayed])
					{
						SetBkColor(hMemDC, 0x00FFFFFF);
						SetTextColor(hMemDC, 0x00000000);

						SelectObject(hMemDC, hFontData);
							if(Table[CurrentTable]->tableData[SubStringDisplayed][c].value > 0xFFFFFF)
								wsprintf(temp, "%08X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							else if (Table[CurrentTable]->tableData[SubStringDisplayed][c].value > 0xFFFF)
								wsprintf(temp, "%06X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							else if (Table[CurrentTable]->tableData[SubStringDisplayed][c].value > 0xFF)
								wsprintf(temp, "%04X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
							else 
								wsprintf(temp, "%02X", Table[CurrentTable]->tableData[SubStringDisplayed][c].value);
						TextOut(hMemDC, 2, blah, temp, strlen(temp));
						SetBkColor(hMemDC, 0x00FFFFFF);
						SetTextColor(hMemDC, 0x00000000);

						_tcscpy(temp, Table[CurrentTable]->tableData[SubStringDisplayed][c].string);
						SelectObject(hMemDC, hFontCodePage);
						TextOut(hMemDC, MaxHexDataWidth + 2, blah, temp, strlen(temp));
						blah += RowHeight;
					}
				}
			}

			// here we take care of drawing the extra one, the one that will
			// be the input for new table values
			if( c == IsClicked.y )
			{
				rect.bottom = RowHeight * ( ( c - ScrollPosition) + 1) ;
				rect.top = RowHeight * ( c - ScrollPosition ) ;
				if(IsClicked.x)
				{
					rect.right = MaxHexDataWidth;
					rect.left = pdis->rcItem.right;
					FillRect(hMemDC, &rect, CreateSolidBrush(0x00000000));

					SetBkColor(hMemDC, 0x00FFFFFF);
					SetTextColor(hMemDC, 0x00000000);
					SelectObject(hMemDC, hFontData);

					SetBkColor(hMemDC, 0x00000000);
					SetTextColor(hMemDC, 0x00FFFFFF);
					blah += RowHeight;
				}
				else
				{
					rect.right = MaxHexDataWidth;
					rect.left = 0;						
					FillRect(hMemDC, &rect, CreateSolidBrush(0x00000000));

					SetBkColor(hMemDC, 0x00000000);
					SetTextColor(hMemDC, 0x00FFFFFF);

					SelectObject(hMemDC, hFontData);
					SetBkColor(hMemDC, 0x00FFFFFF);
					SetTextColor(hMemDC, 0x00000000);
					blah += RowHeight;
					}
			}

			// here is the framing of the window
			FrameRect(hMemDC, &pdis->rcItem, (HBRUSH)GetStockObject (BLACK_BRUSH));
			SetBkColor(hMemDC, 0x00FFFFFF);

			BitBlt(pdis->hDC, 
				pdis->rcItem.left, 
				pdis->rcItem.top, 
				pdis->rcItem.right - pdis->rcItem.left, 
				pdis->rcItem.bottom - pdis->rcItem.top,
					hMemDC, 0, 0, SRCCOPY);

			SelectObject(hMemDC, hbmOld);
			DeleteObject(hbmMem);
			DeleteDC(hMemDC);

		}
		return true;

		case WM_VSCROLL:
			si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_ALL;
			GetScrollInfo(GetDlgItem(hWnd, IDC_VSCROLLBAR), SB_CTL, &si);
			switch(LOWORD(wParam)) {
				case SB_TOP:	// if moved all the way to the top
               		si.nPos = si.nMin;
					break;

				case SB_BOTTOM: // if moved all the way to the bottom
               		si.nPos = si.nMax;
					break;

				case SB_LINEUP: // if moved one line up
               		si.nPos -= 1;
					break;

				case SB_LINEDOWN: // if moved one line down
					si.nPos += 1;
					break;

				case SB_PAGEUP:  // if moved one page up
					si.nPos -= si.nPage;
					break;

				case SB_PAGEDOWN:  // if moved one page down
               		si.nPos += si.nPage;
					break;

				case SB_THUMBTRACK:  // if the thumbscroll is being used
					si.nPos = si.nTrackPos;
					break;

				default:
               		break; 
			}
			SetScrollInfo(GetDlgItem(hWnd, IDC_VSCROLLBAR), SB_CTL, &si, TRUE);
			InvalidateRect(hCustomWindow, NULL, FALSE);
			return true;

		case WM_COMMAND:

			switch(LOWORD(wParam)) {
				case IDC_NEW_SUBTABLE_BUTTON:
					if(DialogBox(hInst, MAKEINTRESOURCE(IDD_NEW_SUBTABLE), hCustomWindow, NewSubTableProc))
					{
						wsprintf(temp, "%02X", Table[CurrentTable]->SubTableKeys[Table[CurrentTable]->SubTables]);
						SendMessage(GetDlgItem(hWnd, IDC_SUBSTRING_COMBO), CB_ADDSTRING, NULL, (LPARAM)temp);						
						//_beginthread(FindSubStringsThread, 0, NULL);
//						Table[CurrentTable]->FindSubStrings();
					}
					return true;

				case IDC_SUBSTRING_COMBO:
					// this is where we get notifications from the combobox
					switch(HIWORD(wParam)) {
						case CBN_SELCHANGE:
							a = SendMessage(GetDlgItem(hWnd, IDC_SUBSTRING_COMBO), CB_GETCURSEL, 0, 0);
							if(a != CB_ERR)
							{
								SubStringDisplayed = a;
								si.cbSize = sizeof(SCROLLINFO);
								si.fMask = SIF_ALL;
								si.nMin = 0;
								si.nMax = Table[CurrentTable]->Entries[SubStringDisplayed] + 1;
								si.nPage =  NumDisplayed;
								SetScrollInfo(GetDlgItem(hWnd, IDC_VSCROLLBAR), SB_CTL, &si, TRUE);
							}
							else 
							{
								;
							}
							InvalidateRect(hCustomWindow, NULL, FALSE);
							return true;
					}
					return false;

				case IDC_COMBO_CODEPAGES:
					return true;

				case IDC_BIGBUTTON:
					
					si.cbSize = sizeof(SCROLLINFO);
					si.fMask = SIF_ALL;
					GetScrollInfo(GetDlgItem(hWnd, IDC_VSCROLLBAR), SB_CTL, &si);
					ScrollPosition = si.nPos;
					OldIsClicked = IsClicked;
					// we're doing english first, the other languages might
					// be a bit of a pain so we're getting this finished
					// off before we move on to them
					if(codepage == 1252)
					{
						GetCursorPos(&CursorPosition);
						ScreenToClient(hCustomWindow, &CursorPosition);
						for(a = 0; a < NumDisplayed - 1; a++)
						{
							if( ( CursorPosition.y > ( RowHeight * a ) ) && 
								( CursorPosition.y <= ( RowHeight * ( a + 1 ) ) ) )
							{
								if(CursorPosition.x > MaxHexDataWidth)
								{
									IsClicked.x = 1;
								}
								else
								{
									IsClicked.x = 0;
								}
								break;
							}
						}
						if(a == ( NumDisplayed - 1 ) )
						{
							if(CursorPosition.x > MaxHexDataWidth)
							{
								IsClicked.x = 1;				
							}
							else
							{
								IsClicked.x = 0;
							}
						}
						IsClicked.y = a + ScrollPosition;
						if(IsClicked.y >= Table[CurrentTable]->Entries[SubStringDisplayed])
							IsClicked.y = Table[CurrentTable]->Entries[SubStringDisplayed];
						if( ( OldIsClicked.y == IsClicked.y ) && 
							( OldIsClicked.x == IsClicked.x ) )
						{
							GetClientRect(hCustomWindow, &rect);
							TopLeft.x = ( OldIsClicked.x ? MaxHexDataWidth + 1 : 0 );
							TopLeft.y = ( OldIsClicked.y - ScrollPosition ) * RowHeight;
							BottomRight.x = ( OldIsClicked.x ? rect.right - MaxHexDataWidth - 3 : MaxHexDataWidth - 1 );
							BottomRight.y = RowHeight + 1;
							if(OldIsClicked.x)
								DialogBox(hInst, MAKEINTRESOURCE(IDD_TABLE_FILE_EDITOR_POPUP), hCustomWindow, TableFileEditorEditWindowProc);
							else 
								DialogBox(hInst, MAKEINTRESOURCE(IDD_TABLE_FILE_HEXEDITOR_POPUP), hCustomWindow, TableFileEditorEditWindowProc);
					
							// this is our code to redo the scrollbars after input and whatnot
							si.cbSize = sizeof(SCROLLINFO);
							si.fMask = SIF_ALL;
							si.nMin = 0;
							si.nMax = Table[CurrentTable]->Entries[SubStringDisplayed] + 1;
							si.nPage = NumDisplayed;
							SetScrollInfo(GetDlgItem(hWnd, IDC_VSCROLLBAR), SB_CTL, &si, TRUE);

						}
					}


					/*******************************************************
					 * ____         ____      ____             ____  _____ *
					 * |      /\    |   \     |        /\     /    \   |   *
					 * |--   /  \   |___/     |--     /  \    \____    |   *
					 * |    /----\  |  \      |      /----\        \   |   *
					 * |   /      \ |   \     |___  /      \  \____/   |   *
					 *                                                     *
					 *******************************************************/
					// this is what we use for far east tables
					else
					{
						GetCursorPos(&CursorPosition);
						ScreenToClient(hCustomWindow, &CursorPosition);
						for(a = 0; a < NumDisplayed - 1; a++)
						{
							if( ( CursorPosition.y > ( RowHeight * a ) ) && 
								( CursorPosition.y <= ( RowHeight * ( a + 1 ) ) ) )
							{
								if(CursorPosition.x > MaxHexDataWidth)
								{
									IsClicked.x = 1;
								}
								else
								{
									IsClicked.x = 0;
								}
								break;
							}
						}
						if(a == ( NumDisplayed - 1 ) )
						{
							if(CursorPosition.x > MaxHexDataWidth)
							{
								IsClicked.x = 1;				
							}
							else
							{
								IsClicked.x = 0;
							}
						}
						IsClicked.y = a + ScrollPosition;
						if(IsClicked.y >= Table[CurrentTable]->Entries[SubStringDisplayed])
							IsClicked.y = Table[CurrentTable]->Entries[SubStringDisplayed];
						if( ( OldIsClicked.y == IsClicked.y ) && 
							( OldIsClicked.x == IsClicked.x ) )
						{
							GetClientRect(hCustomWindow, &rect);
							TopLeft.x = ( OldIsClicked.x ? MaxHexDataWidth + 1 : 0 );
							TopLeft.y = ( OldIsClicked.y - ScrollPosition ) * RowHeight;
							BottomRight.x = ( OldIsClicked.x ? rect.right - MaxHexDataWidth - 3 : MaxHexDataWidth - 1 );
							BottomRight.y = RowHeight + 1;
							if(OldIsClicked.x)
								DialogBox(hInst, MAKEINTRESOURCE(IDD_TABLE_FILE_EDITOR_POPUP), hCustomWindow, TableFileEditorEditWindowProc);
							else 
								DialogBox(hInst, MAKEINTRESOURCE(IDD_TABLE_FILE_HEXEDITOR_POPUP), hCustomWindow, TableFileEditorEditWindowProc);
					
							// this is our code to redo the scrollbars after input and whatnot
							si.cbSize = sizeof(SCROLLINFO);
							si.fMask = SIF_ALL;
							si.nMin = 0;
							si.nMax = Table[CurrentTable]->Entries[SubStringDisplayed] + 1;
							si.nPage = NumDisplayed;
							SetScrollInfo(GetDlgItem(hWnd, IDC_VSCROLLBAR), SB_CTL, &si, TRUE);

						}
					}
					InvalidateRect(hCustomWindow, NULL, FALSE);
					return true;

				case IDOK:
					Table[CurrentTable]->changed = 1;
					DeleteObject(hFontData);
					DeleteObject(hFontCodePage);
					GetDlgItemText(hWnd, IDC_TABLE_NAME, temp, 99);
					if(strlen(temp))
						Table[CurrentTable]->setName(temp);
					GetDlgItemText(hWnd, IDC_COMBO_CODEPAGES, temp, 99);
					Table[CurrentTable]->setCodepage(atoi(temp));
					EndDialog(hWnd, 1);
					break;
				case IDCANCEL:
					Table[CurrentTable]->changed = 0;
					DeleteObject(hFontData);
					DeleteObject(hFontCodePage);
					EndDialog(hWnd, 0);
					break;
			}
	}
	return false;
}

BOOL CALLBACK NewSubTableProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hListView;
	static RANGE subRanges[20];
	static int numsubRanges = 0;

	static RANGE **tempRangeHolder = new RANGE*[Table[CurrentTable]->SubTables + 2];
	static tableEntry** tempHolder = new tableEntry*[Table[CurrentTable]->SubTables + 2]; // we need to allocate enough
		// space for the current subtables (if it's 1 subtable, then we need to allocate
		// 2 pointers, one for the main table, and one for the subtable, but in this instance
		// we not only have that, but we also have the new subtable that we're adding

	LV_COLUMN lvC;
	LV_ITEM lvI; 
	int a, b;
	char szTemp[100];
	switch(message) {
		case WM_INITDIALOG:
			hListView = GetDlgItem(hWnd, IDC_RANGELIST);
			// initialize the first column
		    lvC.mask = LVCF_FMT | LVCF_TEXT | LVCF_SUBITEM | LVCF_WIDTH;
			lvC.fmt = LVCFMT_LEFT; // left-align column
			lvC.cx = 68; // width of column in pixels
			lvC.pszText = TEXT("Start");
			lvC.iSubItem = 0;
			if(ListView_InsertColumn (hListView, 0, &lvC) == -1)
			{
				// debugging
				MessageBox(hWnd, TEXT("First Column not initialised"), PROGRAM_NAME, MB_OK);
				EndDialog(hWnd, 0);
			}

			// initialize the second column
			lvC.mask = LVCF_FMT | LVCF_TEXT | LVCF_SUBITEM | LVCF_WIDTH;
			lvC.fmt = LVCFMT_LEFT; // left-align column
			lvC.cx = 68; // width of column in pixels
			lvC.pszText = TEXT("End");
			lvC.iSubItem = 1;
			if(ListView_InsertColumn (hListView, 1, &lvC) == -1)		
			{
				// debugging
				MessageBox(hWnd, TEXT("Second Column not initialised"), PROGRAM_NAME, MB_OK);
				EndDialog(hWnd, 0);
			}

			return true;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDC_ADDRANGE_BUTTON:
					hListView = GetDlgItem(hWnd, IDC_RANGELIST);
					if(numsubRanges >= 20)
						return true;
					if(!GetDlgItemText(hWnd, IDC_RANGE_START_EDIT, szTemp, 100))
					{
						MessageBox(hWnd, "Please input a start range", PROGRAM_NAME, MB_OK);
						return true;
					}
					else a = strtoul(szTemp, NULL, 0x10);
					
					if(!GetDlgItemText(hWnd, IDC_RANGE_END_EDIT, szTemp, 100))
					{
						MessageBox(hWnd, "Please input an end range", PROGRAM_NAME, MB_OK);
						return true;
					}
					else b = strtoul(szTemp, NULL, 0x10);
	
					subRanges[numsubRanges].start = a;
					subRanges[numsubRanges].end = b;

					wsprintf(szTemp, "%08x", a);
					lvI.mask = LVIF_TEXT ;
					lvI.pszText = szTemp;
					lvI.iItem = numsubRanges;
					lvI.iSubItem = 0;
					ListView_InsertItem(hListView, &lvI);

					wsprintf(szTemp, "%08x", b);
					ListView_SetItemText(hListView, numsubRanges, 1, szTemp);

					SetDlgItemText(hWnd, IDC_RANGE_START_EDIT, "");
					SetDlgItemText(hWnd, IDC_RANGE_END_EDIT, "");

					numsubRanges++;

					return true;

				case IDOK:
					if(!GetDlgItemText(hWnd, IDC_STARTTRIGGER_EDIT, szTemp, 100))
					{
						MessageBox(hWnd, "Please input a start trigger", PROGRAM_NAME, MB_OK);
						return true;
					}
					a = strtoul(szTemp, NULL, 16);
					if(!GetDlgItemText(hWnd, IDC_ENDTRIGGER_EDIT, szTemp, 100))
					{
						MessageBox(hWnd, "Please input an end trigger", PROGRAM_NAME, MB_OK);
						return true;
					}					
					b = strtoul(szTemp, NULL, 16);
					
					// now I have to do the code to actually add the new subtable to the
					// current table file, what I"m thinking of doing, is just allocating
					// another 2d array, saving the old one there, then allocating a new
					// 2d array with room for the new subtable, and simply placing the old
					// one plus the new subtable, in that one.  I think that's how I'll do
					// it as it seems to be the way that would make the most sense, at least
					// it makes the most sense at the moment, who knows what I'll think up 
					// in my sleep that might make my job 100x easier, oh well, I think
					// i'm going to go to bed now.  It's 2am and I have work tomorrow, today
					// has been rather productive though, and it looks like friday will be
					// a very good day for development and might signal the end of the development
					// on the table file editor.

					Table[CurrentTable]->AddSubTable(a,b);

					for(a = 0; a < numsubRanges; a++)
					{
						Table[CurrentTable]->AddRange(subRanges[a].start,subRanges[a].end, Table[CurrentTable]->SubTables);
					}

					EndDialog(hWnd, 1);
					return true;
				case IDCANCEL:
					EndDialog(hWnd, 0);
					return true;

			}
	}
	return false;
}
