/*
 * Hexecute 3.0
 * About.cpp
 * copyright 2000 Mike Walston
 * 
 * this is the window procedure for the about dialog box
 */


#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"


BOOL CALLBACK AboutProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
//	HWND Desktop;
//	RECT Screen;
	switch(msg) {
		case WM_INITDIALOG:
			return true;

		case WM_CHAR:
			return true;
		case WM_KEYDOWN:
			EndDialog(hWnd, 1);
			return true;
		case WM_COMMAND:
			EndDialog(hWnd, 1);
			return true;
	}
	return false;
}

BOOL CALLBACK SplashProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HWND Desktop;
	RECT Screen;
	switch(msg) {
		case WM_INITDIALOG:
			Desktop = GetDesktopWindow();
			GetClientRect(Desktop, &Screen);
			MoveWindow(hWnd, ( Screen.right / 2 ) - 200, ( Screen.bottom / 2 ) - 143, 400, 286, TRUE);
			SetTimer(hWnd, TIMER_SPLASH, 3000, NULL);
			return true;

		case WM_TIMER:
			switch(wParam) {
				case TIMER_SPLASH:
					EndDialog(hWnd, 1);
			}
			return true;
	}
	return false;
}
