/*
 * Hexecute 3.0
 * InsertProc.h
 * copyright 2000 Mike Walston
 *
 * This is the file that holds WinProc for the table based 
 * insertion dialog
 */


#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <richedit.h>
#include <tchar.h>
#include "resource.h"
#include "hexecute_defines.h"
#include "hexecute_globals.h"
#include "hexecute_types.h"

#pragma warning (disable : 4700)
#pragma warning (disable : 4101)
/*
BOOL CALLBACK InsertProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
		
	COMBOBOXTEXT ComboBoxText;
	HWND hWndTemp;
	TCHAR input_point[1024];
	char blahblah[100], temp2[500];
	tableEntry* yeehaw;
	int MASK[4] = { 0xFF, 0xFF00, 0xFF0000, 0xFF000000 } ;
	int a, l, b, q, c, o, i, r = 0, romh;
	switch(message){
		case WM_INITDIALOG:
				hWndTemp = GetDlgItem(hWnd, IDC_TBL_LIST_COMBO);

				ComboBoxText.iNumStrings = TotalTables;
				ComboBoxText.Text = new char*[TotalTables];
				for(a = 0; a < TotalTables; a++)
				{
					ComboBoxText.Text[a] = new char[100];
					_tcscpy( ComboBoxText.Text[a], Table[a]->getName());
				}
				SetComboBoxText(hWndTemp, &ComboBoxText);
				SetDlgItemText(hWnd, IDC_TBL_LIST_COMBO, Table[CurrentTable]->getName());
			return (TRUE);

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
			case IDOK:
	
				mmhmm = CurrentPosition + ( yMouse * 16 );
				GetDlgItemText(hWnd, IDC_EDIT1, input_point, 1023);
				GetDlgItemText(hWnd, IDC_TBL_LIST_COMBO, blahblah, 100);
				//
				for(a = 0; a < TotalTables; a++)
				{
					if(!strcmp(blahblah, Table[a]->getName()))
						break;
				}
//				Table[a]->sortForInsertion();
				// here we do the actual insert into the file
				romh = strlen(input_point);
				DoInsertConversion(input_point);
				for( l = 0; l < romh;) {
					for( b = Table[a]->getLongestEntry() ; b > 0 ; b-- )
					{
						// we'll run through our options starting with the longest string
						// so as to get the maximum compressoin that we can get from a DTE
						// based table
						for(q = 0; q < b; q++) {
							temp2[q] = input_point[q + l];
						}
						temp2[q] = 0x00;
						if( Table[a]->getMatchingNode(temp2) ) {
							yeehaw = Table[a]->getMatchingNode(temp2);
							if ( yeehaw->value > 0xFFFFFF )
								c = 4;
							else if ( yeehaw->value > 0xFFFF )
								c = 3;
							else if ( yeehaw->value > 0xFF )
								c = 2;
							else c = 1;
							for(o = c, i = 0; o > 0; o--, i++)
							{
								SetFileByte(CurrentStartAddress + mmhmm + i + r, 
									( yeehaw->value & MASK[ o - 1 ] ) >> ( 8 * ( o - 1 ) ));
								r += c;
							}
							break;
						}
					}
					l += b;
				}
				// end of the actual insertion in the file
//				Table[a]->sort();

				for(a = 0; a < ComboBoxText.iNumStrings; a++)
				{
					delete[] ComboBoxText.Text[a];
				}
				delete[] ComboBoxText.Text;
				EndDialog(hWnd, 1);
				return (TRUE);
			
			case IDCANCEL:
				for(a = 0; a < ComboBoxText.iNumStrings; a++)
				{
					delete[] ComboBoxText.Text[a];
				}
				delete[] ComboBoxText.Text;
				EndDialog(hWnd, 0);
				return (TRUE);
			}
		default:
			return (FALSE);
	}
}
*/
BOOL CALLBACK TableBasedDirectInputProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	POINT blah;
	RECT bleh;
	CHARRANGE cr;
	int l, b, q, c, o, i, r = 0, romh;
	tableEntry* yeehaw;
	int MASK[4] = { 0xFF, 0xFF00, 0xFF0000, 0xFF000000 } ;
	char temp2[500], whatever[4];
	char script[65356];
	historyevent heEvent;

		switch(message){
			case WM_INITDIALOG:
				whatever[0] = f00;
				whatever[1] = 0x00;
				GetClientRect(hWnd, &bleh);
				blah.x = Positions[yMouse][CurrentPosition] - ( HorizontalOffset * cxChar) ;
				blah.y = yMouse * cyChar;
				ClientToScreen(hWndData, &blah);
				MoveWindow(hWnd, blah.x, blah.y, bleh.right - bleh.left , bleh.bottom - bleh.top,TRUE);
				SendDlgItemMessage(hWnd, IDC_EDIT1, EM_SETLIMITTEXT, 199, 0);
				SendDlgItemMessage(hWnd, IDC_EDIT1, WM_CHAR, (WPARAM)f00, 0);
				SendDlgItemMessage(hWnd, IDC_EDIT1, EM_SETSEL, -1, 0);
				SetFocus(GetDlgItem(hWnd, IDC_EDIT1));
				return (false);

			case WM_COMMAND:
				switch(HIWORD(wParam)) {
					case EN_KILLFOCUS:
						EndDialog(hWnd, 0);
						return (TRUE);
	
					case EN_UPDATE:
						GetDlgItemText(hWnd, IDC_EDIT1, script, 199);
						if(script[strlen(script) - 1] == '\n')
						{ 
							mmhmm = ( CurrentPosition % 16 ) + ( yMouse * 16 );
							// should i leave the newline in there or not? 
							// at the moment, i think not
							script[strlen(script) - 1] = 0x00;
							heEvent.data = new char[strlen(script)];
							memcpy(heEvent.data, File + mmhmm, strlen(script));
							heEvent.offset = mmhmm;
			
							// here is where we do the inserting
//							Table[CurrentTable]->sortForInsertion();
							romh = strlen(script) - 1;
							DoInsertConversion(script);
							for( l = 0; l < romh;) {
								for( b = Table[CurrentTable]->getLongestEntry() ; b > 0 ; b-- )
								{
									// we'll run through our options starting with the longest string
									// so as to get the maximum compressoin that we can get from a DTE
									// based table
									for(q = 0; q < b; q++) {
										temp2[q] = script[q + l];
									}
									temp2[q] = 0x00;
									if( Table[CurrentTable]->getMatchingNode(temp2) ) {
										yeehaw = Table[CurrentTable]->getMatchingNode(temp2);
										if ( yeehaw->value > 0xFFFFFF )
											c = 4;
										else if ( yeehaw->value > 0xFFFF )
											c = 3;
										else if ( yeehaw->value > 0xFF )
											c = 2;
										else c = 1;
										for(o = c, i = 0; o > 0; o--, i++)
										{
											SetFileByte(CurrentStartAddress + mmhmm + i + r,
												( yeehaw->value & MASK[ o - 1 ] ) >> ( 8 * ( o - 1 ) ));
											r += c;
										}
										break;
									}

								}
							if(!b)
								b++;
							l += b;								
							}

							heEvent.size = r;
							History.push(heEvent);

							yMouse += ( ( CurrentPosition % 16 ) + r ) / 16;
							CurrentPosition += r % 16;

							EndDialog(hWnd, 1);
							return (TRUE);
						}
	
					default:
						return (FALSE);
				}
				return (TRUE);
			default:
				return (FALSE);
		}
}

BOOL CALLBACK ScriptInsertProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	tableEntry* yeehaw;
	FILE* Whatchamacallit;
	int HexOrDec = 0;
	int MASK[4] = { 0xFF, 0xFF00, 0xFF0000, 0xFF000000 } ;
	LPTSTR path = (LPTSTR)malloc(_MAX_PATH);
	ZeroMemory(path, sizeof(path));
	OPENFILENAME ofn;
	COMBOBOXTEXT ComboBoxText;
	HWND hWndTemp;
	char temp[MAX_PATH], filename[MAX_PATH], *script,temp2[500];
	static char szTitleName[50];
	historyevent heEvent;
	int InsertionAddress, ScriptLength;
	int a, l, b, q, c, o, i, r = 0, romh;
	switch(message){
			case WM_INITDIALOG:
				hWndTemp = GetDlgItem(hWnd, IDC_COMBO1);

				ComboBoxText.iNumStrings = TotalTables + 1;
				ComboBoxText.Text = new char*[TotalTables + 1];
				for(a = 1; a < ComboBoxText.iNumStrings; a++)
				{
					ComboBoxText.Text[a] = new char[100];
					_tcscpy( ComboBoxText.Text[a], Table[a - 1]->getName());
				}
				ComboBoxText.Text[0] = new char[100];
				_tcscpy(ComboBoxText.Text[0], TEXT("none"));
				SetComboBoxText(hWndTemp, &ComboBoxText);
				if(CurrentTable != -1)
					SetDlgItemText(hWnd, IDC_COMBO1, Table[CurrentTable]->getName());
				else 
					SetDlgItemText(hWnd, IDC_TBL_LIST_COMBO, "none");
				CheckDlgButton(hWnd, IDC_RADIOHEX, 1);
				mmhmm = CurrentPosition + ( yMouse * 16 );
				wsprintf(temp, "%x", mmhmm);
				SetDlgItemText(hWnd, IDC_EDITADDRESS, temp);
				return (TRUE);

			case WM_COMMAND:
				switch (LOWORD(wParam)) {					
					case IDC_RADIOHEX:
						HexOrDec = 0;
						wsprintf(temp, "%x", mmhmm);
						SetDlgItemText(hWnd, IDC_EDITADDRESS, temp);	
						return (TRUE);

					case IDC_RADIODEC:
						HexOrDec = 1;
						wsprintf(temp, "%d", mmhmm);
						SetDlgItemText(hWnd, IDC_EDITADDRESS, temp);
						return (TRUE);

					case IDC_BUTTON1: // the button that opens the browse dialog for the script
						ZeroMemory(&ofn, sizeof(OPENFILENAME));
						ofn.lStructSize      = sizeof(OPENFILENAME);
						ofn.hwndOwner 			= hWnd;
						ofn.nMaxFile			= MAX_PATH;
						ofn.nMaxFileTitle 	= MAX_PATH;
						ofn.lpstrFile			= path;
						ofn.lpstrFileTitle 	= szTitleName;
						ofn.lpstrTitle	  		= TEXT("Open a Script");
						ofn.lpstrFilter      = (LPSTR)TEXT("Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0");
						ofn.Flags				= OFN_EXPLORER;
						if(!GetOpenFileName(&ofn)) {
							return TRUE;
						} else {
							SetDlgItemText(hWnd, IDC_SCRIPT_NAME, path);
						}						
						return (TRUE);

					// this is the option that says we actually insert the script				
					case IDOK:
						GetDlgItemText(hWnd, IDC_SCRIPT_NAME, temp, MAX_PATH);
						_tcscpy(filename, temp);
						GetDlgItemText(hWnd, IDC_EDITADDRESS, temp, 100);
						if(HexOrDec) {
							InsertionAddress = strtoul(temp, NULL, 10);
						} else {
							InsertionAddress = strtoul(temp, NULL, 16);;
						}
						GetDlgItemText(hWnd, IDC_COMBO1, temp, 100);
	
						// the next 7 lines of code are common to my regular insertion
						// and to my table based insertion, and I didn't want to have
						// them in the code twice, makes for harder maintenance.
						Whatchamacallit = fopen(filename, "r");
						fseek(Whatchamacallit, 0, SEEK_END);
						ScriptLength = ftell(Whatchamacallit);
						script = new char[ScriptLength + 2];
						memset(script, 0x00, ScriptLength + 2);
						fseek(Whatchamacallit, 0, SEEK_SET);
						fread(script, 1, ScriptLength, Whatchamacallit);
						fclose(Whatchamacallit);

						heEvent.data = new char[ScriptLength];
						memcpy(heEvent.data, File + InsertionAddress, ScriptLength);
						heEvent.offset = InsertionAddress;

						if(strcmp(temp, "none"))
						{
							for(a = 0; a < TotalTables; a++)
							{
								if(!strcmp(temp, Table[a]->getName()))
									break;
							}
//							Table[a]->sortForInsertion();
							romh = strlen(script);
							DoInsertConversion(script);
							for( l = 0; l < romh;) {
								for( b = Table[a]->getLongestEntry() ; b > 0 ; b-- )
								{
									// we'll run through our options starting with the longest string
									// so as to get the maximum compressoin that we can get from a DTE
									// based table
									for(q = 0; q < b; q++) {
										temp2[q] = script[q + l];
									}
									temp2[q] = 0x00;
									if( Table[a]->getMatchingNode(temp2) ) {
										yeehaw = Table[a]->getMatchingNode(temp2);
										if ( yeehaw->value > 0xFFFFFF )
											c = 4;
										else if ( yeehaw->value > 0xFFFF )
											c = 3;
										else if ( yeehaw->value > 0xFF )
											c = 2;
										else c = 1;
										for(o = c, i = 0; o > 0; o--, i++)
										{
											SetFileByte(CurrentStartAddress + mmhmm + i + r,
												( yeehaw->value & MASK[ o - 1 ] ) >> ( 8 * ( o - 1 ) ));
											r += c;
										}
										break;
									}
								}
								l += b;
							}
//							Table[a]->sort();
							heEvent.size = r;
							History.push(heEvent);
						}
						else
						{
							// this is where we simply write the raw data into the memory
							// no conversions like we do with table files are necessary
							SafeMemCopy(File, InsertionAddress, script, ScriptLength);
							heEvent.size = ScriptLength;
							History.push(heEvent);
						}
						delete[] script;
						free(path);
						for(a = 0; a < ComboBoxText.iNumStrings; a++)
						{
							delete[] ComboBoxText.Text[a];
						}
						delete[] ComboBoxText.Text;
						EndDialog(hWnd, 1);
						return (TRUE);
					// this option simply cancels out, so it is complete, as
					// we just throw everything away
					case IDCANCEL:
						delete[] script;
						free(path);
						for(a = 0; a < ComboBoxText.iNumStrings; a++)
						{
							delete[] ComboBoxText.Text[a];
						}
						delete[] ComboBoxText.Text;
						EndDialog(hWnd, 0);
						return (TRUE);
				}
			default:
				return (FALSE);
	}
}